// ####################################################################################
// Includes
// ####################################################################################

#include "stdafx.h"
#include "internal.h"

using namespace GregorView::Internal;


// ####################################################################################
// Init/Fin
// ####################################################################################

CAllocator::CAllocator(void)
{
	HRESULT hres = SHGetMalloc(&m_pMalloc);
	if(FAILED(hres)){
		m_pMalloc = NULL; // make sure it's NULL so we can check it
		::GetTracer().TraceFormatted("Can't get the Shell's allocator, hres <%d>", hres);
	}
}

CAllocator::~CAllocator(void)
{
	if(m_pMalloc != NULL){
		m_pMalloc->Release();
	}
}


// ####################################################################################
// Methods
// ####################################################################################

void * CAllocator::Allocate(size_t size)
{
	void * p = NULL;
	if(m_pMalloc != NULL){
		p = m_pMalloc->Alloc(size);
		if(p != NULL){
			memset(p, 0, size);
		}
	}
	return p;
}

void CAllocator::Free(void * p)
{
	if(m_pMalloc != NULL && p != NULL){
		m_pMalloc->Free(p);
	}
}
