// ####################################################################################
// Includes
// ####################################################################################

#include "stdafx.h"
#include "managed.h"

#using <mscorlib.dll>

using namespace GregorView::Managed;


// ####################################################################################
// Init/Fin
// ####################################################################################

CFolderBase::CFolderBase(String * sDisplayName) : CItemBase(NULL, sDisplayName)
{
	m_pSubFolders = NULL;
}

CFolderBase::CFolderBase(CFolderBase * pParent, String * sDisplayName) : CItemBase(pParent, sDisplayName)
{
	m_pSubFolders = NULL;
}


// ####################################################################################
// Properties
// ####################################################################################

NFolderCollection * CFolderBase::get_SubFolders(void)
{
	if(m_pSubFolders == NULL){
		// create collection
		m_pSubFolders = new NFolderCollection(this);
		// ask implementor fill it
		this->ReadSubFolders();
	}
	return m_pSubFolders;
}

bool CFolderBase::get_HasSubFolders(void)
{
	// derived classes may use a more performant implementation
	return (this->SubFolders->Count > 0);
}

GregorView::Managed::ShellAttributes CFolderBase::get_ShellAttributes(void)
{
	DWORD dwAttribs = (DWORD) GregorView::Managed::ShellAttributes::Folder;
	if(this->HasSubFolders){
		dwAttribs |= (DWORD)GregorView::Managed::ShellAttributes::HasSubFolder;
	}
	return (GregorView::Managed::ShellAttributes)dwAttribs;
}


// ####################################################################################
// Methods
// ####################################################################################

 void CFolderBase::ReleaseViewWindow(IntPtr hWnd)
 {
	// optional clean-up change for implementor
	return;
 }
 