#pragma once

#include "stdafx.h"
#include "managed.h"

namespace GregorView { namespace Internal {

class CGregorViewEnumerator : public IEnumIDList
{
	public:
		// init/fin
		CGregorViewEnumerator(GregorView::Managed::CFolderBase * pFolder);
		~CGregorViewEnumerator(void);

		// IUnknown
		STDMETHODIMP QueryInterface(REFIID riid, void ** ppObj);
		STDMETHODIMP_(ULONG) AddRef(void);
		STDMETHODIMP_(ULONG) Release(void);

		// IEnumIDList
		STDMETHODIMP Clone(IEnumIDList ** ppEnum);
		STDMETHODIMP Next(ULONG celt, ITEMIDLIST ** ppOut, ULONG * pCountFetched);
		STDMETHODIMP Reset(void);
		STDMETHODIMP Skip(ULONG celt);

	private:
		// fields
		CCounter m_RefCounter;
		gcroot<GregorView::Managed::CFolderBase*> m_pFolder;
		int m_NextIndex;
};


}; };
