#pragma once

#include "stdafx.h"
#include "CGregorViewShellFolder.h"
#include "managed.h"

#using <mscorlib.dll>
#using <System.dll>

using namespace System;
using namespace System::Runtime::InteropServices;

namespace GregorView { namespace Internal {

class CGregorViewExtensionPoint
{
	public:
		// init/fin
		CGregorViewExtensionPoint(REFCLSID rclsid, const char * pszClassId, const char * pszManagedDllPath);
		~CGregorViewExtensionPoint(void);
		// ID properties
		const CLSID & GetClassId(void);
		const char * GetClassIdAsString(void);
		const ITEMIDLIST * GetIDList(void);
		// pidl methods
		bool SaveNseRoot(const ITEMIDLIST * pcidl);
		const ITEMIDLIST * GetNseRoot(void);
		const ITEMIDLIST * SkipNseRoot(const ITEMIDLIST * pcidl);
		// connection methods
		GregorView::Managed::CConnector * GetConnector(void);
		GregorView::Managed::CFolderBase * GetFolder(CGregorViewShellFolder * pShellFolder);

	private:
		// fields
		CLSID m_ClassId;
		char m_szClassId[100];
		const ITEMIDLIST * m_pIDListNseRoot; // fully-qualified
		char m_szManagedDllPath[MAX_PATH];
		// references to managed objects
		gcroot<GregorView::Managed::CConnector*> m_pConnector;

};

}; };
