#pragma once

#include "stdafx.h"

class CGregorViewFolder : public IShellFolder, public IPersistFolder
{
	public:

		// init,Fin
		CGregorViewFolder(void);
		~CGregorViewFolder(void);

		// IUnknown
		STDMETHODIMP QueryInterface(REFIID riid, void ** ppObj);
		STDMETHODIMP_(ULONG) AddRef(void);
		STDMETHODIMP_(ULONG) Release(void);
		
		// IShellFolder
		STDMETHODIMP ParseDisplayName(
								HWND hwndOwner,
								LPBC pbc,
								LPOLESTR lpszDisplayName,
								ULONG FAR* pchEaten,
								LPITEMIDLIST * ppidl,
								ULONG *pdwAttributes);
 
 		STDMETHODIMP EnumObjects(
 								HWND hwndOwner,
								DWORD grfFlags,
								LPENUMIDLIST * ppenumIDList);
 
		STDMETHODIMP BindToObject( 
								LPCITEMIDLIST pidl,
								LPBC pbc,
								REFIID riid,
								LPVOID FAR* ppvObj);
								
		STDMETHODIMP BindToStorage( 
								LPCITEMIDLIST pidl,  
								LPBC pbc, 
								REFIID riid,  
								LPVOID FAR* ppvObj); 

		STDMETHODIMP CompareIDs(
								LPARAM lParam,
								LPCITEMIDLIST pidl1,
								LPCITEMIDLIST pidl2);
								
		STDMETHODIMP CreateViewObject(
								HWND hwndOwner,
								REFIID riid,
								LPVOID FAR* ppvObj);
								
		STDMETHODIMP GetAttributesOf(
								UINT cidl,
								LPCITEMIDLIST FAR* apidl,
								ULONG FAR* rgfInOut);
								
		STDMETHODIMP GetUIObjectOf(
								HWND hwndOwner,
								UINT cidl,
								LPCITEMIDLIST FAR* apidl,
								REFIID riid,
								UINT FAR* prgfInOut,
								LPVOID FAR* ppvObj);
								
		STDMETHODIMP GetDisplayNameOf( 
								LPCITEMIDLIST pidl,
								DWORD dwFlags,
								LPSTRRET lpName);

		STDMETHODIMP SetNameOf(
								HWND hwndOwner,
								LPCITEMIDLIST pidl,
								LPCOLESTR lpszName,
								DWORD dwReserved,
								LPITEMIDLIST FAR* ppidlOut);

		// IPersistFolder
		STDMETHODIMP GetClassID(CLSID *pClassID); // IPersist
		STDMETHODIMP Initialize(const ITEMIDLIST * pidl);

		// other
		const ITEMIDLIST * GetIDList(void);

	private:

		// fields
		CCounter m_RefCounter;
		const ITEMIDLIST * m_pIDList; // fully-qualified
	
};
