#pragma once
#include <unknwn.h>
#include <shlobj.h>

namespace GregorView { namespace Internal {

class CGregorViewFolderView : public IShellView
{
	public:

		// init/fin
		CGregorViewFolderView(CGregorViewShellFolder * pShellFolder, REFCLSID rclsid, HWND hWndOwner);
		~CGregorViewFolderView(void);

		// IUnknown
		STDMETHODIMP QueryInterface(REFIID riid, void ** ppObj);
		STDMETHODIMP_(ULONG) AddRef(void);
		STDMETHODIMP_(ULONG) Release(void);

		// IShellView
		STDMETHODIMP GetWindow(HWND * pHwnd); // IOleWindow
		
		STDMETHODIMP ContextSensitiveHelp(BOOL fEnterMode); // IOleWindow
		
		STDMETHODIMP CGregorViewFolderView::TranslateAccelerator(LPMSG lpmsg);
		
		STDMETHODIMP CGregorViewFolderView::EnableModeless(BOOL fEnable);
		
		STDMETHODIMP CGregorViewFolderView::UIActivate(UINT uState);
		
		STDMETHODIMP CGregorViewFolderView::Refresh();
		
		STDMETHODIMP CGregorViewFolderView::CreateViewWindow(
											IShellView  *lpPrevView, 
											LPCFOLDERSETTINGS lpfs,
											IShellBrowser  * psb, 
											RECT * prcView,
											HWND  *phWnd);

		STDMETHODIMP CGregorViewFolderView::DestroyViewWindow();

		STDMETHODIMP CGregorViewFolderView::GetCurrentInfo(LPFOLDERSETTINGS lpfs);

		STDMETHODIMP CGregorViewFolderView::AddPropertySheetPages(
											DWORD dwReserved, 
											LPFNADDPROPSHEETPAGE lpfn,
											LPARAM lparam);
 
		STDMETHODIMP CGregorViewFolderView::SaveViewState();
 
		STDMETHODIMP CGregorViewFolderView::SelectItem(
											LPCITEMIDLIST pidlItem,
											UINT uFlags);
 
		STDMETHODIMP CGregorViewFolderView::GetItemObject(
											UINT uItem,
											REFIID riid, 
							                LPVOID *ppv);

	private:

		// fields
		CCounter m_RefCounter;
		CGregorViewShellFolder * m_pShellFolder; // hope this doesn't lead to cycles
		HWND m_hWndOwner;
		HWND m_hWnd;
		CLSID m_ClassId;

};

}; };
