#pragma once

#include "stdafx.h"

// IMPORTANT:
// Do not use virtual functions in this class.
// Do not rely on a destructor.

// This class represents data in a Shell Item ID (SHITEMID) that we have created.
// The ID represents only a single item ID. No assumptions should be made about
// adjacent IDs. Instances are allocated and freed with special versions of oper-
// ators new and delete, which use the Shell's allocator.

namespace GregorView { namespace Internal {

#define SIZE_DISPLAYNAME 28

class CGregorViewId // : public NOTHING
{
	public:

		// static operators
		void * operator new(size_t size); // ... provide placement new for multi-level ID lists if necessary
		void   operator delete(void * p);
		
		// static functions
		static CGregorViewId * FromItemID(const ITEMIDLIST * pcidl);

		// init/fin
		CGregorViewId(DWORD dwAttribs, const char * pszName);

		// methods
		DWORD GetAttribs(void);
		const char * GetName(void);
		void GetName(STRRET * pStr);
		void GetName(STRRET * pStr, const char * pszParentNames);
		void ConcatNameTo(char * psz, size_t bufferSize);
		signed short CompareTo(CGregorViewId * that);
		ITEMIDLIST * AsItemID(void);

	private:
		WORD   cb;						// size of entire structure, excluding terminator
		WORD   wReserved;				// reserved
		DWORD  dwReserved;				// reserved
		DWORD  dwAttribs;				// shell item attributes (SFGAO)
		char   szName[SIZE_DISPLAYNAME];// item name (must be unique in a folder)

}; // class CGregorId

}; };

