// ####################################################################################
// Includes
// ####################################################################################

#include "stdafx.h"
#include "managed.h"
#include "internal.h"

#using <mscorlib.dll>

using namespace System;
using namespace GregorView::Managed;


// ####################################################################################
// Init/Fin
// ####################################################################################

CItemBase::CItemBase(CFolderBase * pParent, String * sDisplayName)
{
	// validate
	if(sDisplayName == NULL){
		throw new ArgumentNullException();
	}
	if(sDisplayName->Length < 1 || sDisplayName->Length >= SIZE_DISPLAYNAME){
		// must not be empty, and smaller (!) the SIZE_DISPLAYNAME
		throw new ArgumentException();
	}
	if(sDisplayName->IndexOf('\\') >= 0 || sDisplayName->IndexOf('/') >= 0){ // ... check against other illegal chars
		throw new ArgumentException();
	}
	// encaps
	m_pParentFolder = pParent;
	m_pDisplayName = sDisplayName;
}


// ####################################################################################
// Properties
// ####################################################################################

CFolderBase * CItemBase::get_ParentFolder(void)
{
	return m_pParentFolder;
}

String * CItemBase::get_DisplayName(void)
{
	return m_pDisplayName;
}
