// ####################################################################################
// Includes
// ####################################################################################

#include "stdafx.h"
#include "stdio.h"
#include "stdarg.h"
#include "tchar.h" // _vstpring (vsprint | vswprintf)
#include "internal.h"

using namespace GregorView::Internal;


// ####################################################################################
// Defines
// ####################################################################################

#define CRLF            "\r\n"
#define STRLEN_BYTE(S)  (strlen(S) * sizeof((S)[0]))
#undef TRACE_ON


// ####################################################################################
// Init/Fin
// ####################################################################################

CTracer::CTracer(void)
{
#ifdef TRACE_ON
	m_FileHandle = INVALID_HANDLE_VALUE;
	m_FileHandle = CreateFile("GregorView.log", GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
#endif
}

CTracer::~CTracer(void)
{
#ifdef TRACE_ON
	if(m_FileHandle != INVALID_HANDLE_VALUE){
		FlushFileBuffers(m_FileHandle);
		CloseHandle(m_FileHandle);
	}
#endif
}


// ####################################################################################
// Methods
// ####################################################################################

void CTracer::Trace(const TCHAR * psz)
{
#ifdef TRACE_ON
	if(m_FileHandle != INVALID_HANDLE_VALUE && psz != NULL){
		DWORD cbWritten = 0;
		(void)WriteFile(m_FileHandle, psz, (DWORD)STRLEN_BYTE(psz), &cbWritten, NULL);
		(void)WriteFile(m_FileHandle, CRLF, (DWORD)STRLEN_BYTE(CRLF), &cbWritten, NULL);
		FlushFileBuffers(m_FileHandle);
	}
#endif
}

void CTracer::Trace(const TCHAR * psz, int i)
{
#ifdef TRACE_ON
	if(m_FileHandle != INVALID_HANDLE_VALUE && psz != NULL){
		TCHAR sz[1000];
		wsprintf(sz, "%s <%d>", psz, i);
		this->Trace(sz);
	}
#endif
}

void CTracer::Trace(const TCHAR * psz, const void * p)
{
#ifdef TRACE_ON
	if(m_FileHandle != INVALID_HANDLE_VALUE && psz != NULL){
		TCHAR sz[1000];
		wsprintf(sz, "%s <0x%x>", psz, p);
		this->Trace(sz);
	}
#endif
}

void CTracer::TraceFormatted(const TCHAR * pszFormat, ...)
{
#ifdef TRACE_ON
	if(m_FileHandle != INVALID_HANDLE_VALUE && pszFormat != NULL){
		TCHAR sz[1000];
		va_list args;
		va_start(args, pszFormat);
		_vstprintf(sz, pszFormat, args);
		va_end(args);
		this->Trace(sz);
	}
#endif
}



