#include "StdAfx.h"
#include "CUnknown.h"

// ####################################################################################
// Init,Fin
// ####################################################################################

CUnknown::CUnknown(void)
{

}


// ####################################################################################
// IUnknown
// ####################################################################################

STDMETHODIMP CUnknown::QueryInterface(REFIID riid, void ** ppObj)
{
	*ppObj = NULL;
	if(riid == IID_IUnknown || riid == IID_IClassFactory){
		*ppObj = (void*)(IClassFactory*)this;
		this->AddRef();
		return NOERROR;
	}else{
		return E_NOINTERFACE;
	}
}

STDMETHODIMP_(ULONG) CUnknown::AddRef(void)
{
	m_RefCounter.Increment();
	return m_RefCounter.GetCount();
}

STDMETHODIMP_(ULONG) CUnknown::Release(void)
{
	if(m_RefCounter.Decrement()){
		delete this;
	}
	return m_RefCounter.GetCount();
}
