Option Strict On

Imports System
Imports System.Drawing
Imports System.Windows.Forms

Namespace LisaView


    Public Class CLisaViewConnector
            Inherits GregorView.Managed.CConnector

        Private m_RootFolder As CLisaFolder

        Public Sub New()
            MyBase.New()
        End Sub

        Public Overrides Function GetRootFolder() As GregorView.Managed.CFolderBase
            If m_RootFolder Is Nothing Then
                m_RootFolder = New CLisaFolder()
            End If
            Return m_RootFolder
        End Function

        Public Function GetTruth() As Integer
            Return 42
        End Function

    End Class

    Public Class CLisaFolder
            Inherits GregorView.Managed.CFolderBase

        Private m_ViewWindow As ContainerControl

        Public Sub New()
            MyBase.New("Lisa View")
        End Sub
        Public Sub New(ByVal parent As CLisaFolder, ByVal sDisplayName As String)
            MyBase.New(parent, sDisplayName)
        End Sub

        Public Overrides Function GetViewWindow() As IntPtr
            If m_ViewWindow Is Nothing Then
                m_ViewWindow = New ContainerControl()
                m_ViewWindow.BackColor = Color.Navy
                Dim btn As New Button()
                btn.Size = New Size(120, 22)
                btn.Text = ".NET " & Me.DisplayName
                btn.ForeColor = Color.White
                m_ViewWindow.Controls.Add(btn)
            End If
            Return m_ViewWindow.Handle
        End Function

        Public Overrides Sub ReleaseViewWindow(ByVal hWnd As IntPtr)
            ' we just leave the form alive; otherwise we could clean things up
            ' since we also keep a reference, we don't need hWnd; otherwise we
            ' could call Control.FromHandle()
        End Sub

        Protected Overrides Sub ReadSubFolders()
            If Me.ParentFolder Is Nothing Then
                ' test data: root
                Me.SubFolders.Add(New CLisaFolder(Me, "Uno"))
                Me.SubFolders.Add(New CLisaFolder(Me, "Dos"))
                Me.SubFolders.Add(New CLisaFolder(Me, "Tres"))
            ElseIf Me.ParentFolder.ParentFolder Is Nothing Then
                ' test data: one below root
                Me.SubFolders.Add(New CLisaFolder(Me, "One"))
                Me.SubFolders.Add(New CLisaFolder(Me, "Two"))
                Me.SubFolders.Add(New CLisaFolder(Me, "Three"))
            ElseIf Me.ParentFolder.ParentFolder.ParentFolder Is Nothing Then
                ' test data: two below root
                Me.SubFolders.Add(New CLisaFolder(Me, "Eins"))
                Me.SubFolders.Add(New CLisaFolder(Me, "Zwei"))
                Me.SubFolders.Add(New CLisaFolder(Me, "Drei"))
            End If
        End Sub

    End Class

End Namespace