// ####################################################################################
// Includes
// ####################################################################################

#include "stdafx.h"
#include "managed.h"

#using <mscorlib.dll>

using namespace System;
using namespace System::Collections;
using namespace GregorView::Managed;


// ####################################################################################
// Init/Fin
// ####################################################################################

NFolderCollection::NFolderCollection(CFolderBase * pParent)
{
	m_pParentFolder = pParent;
}


// ####################################################################################
// Properties
// ####################################################################################

CFolderBase * NFolderCollection::get_ParentFolder(void)
{
	return m_pParentFolder;
}

CFolderBase * NFolderCollection::get_Element(int index)
{
	// MVC++ doesn't get it: CollectionBase implements IList *privately*, so
	// a public property "NFolderCollection::Item" should not conflict at all
	// with what's defined in IList; instead, we get some crap error message
	// about covariance.
	return __try_cast<CFolderBase*>(this->InnerList->get_Item(index));
}

CFolderBase * NFolderCollection::get_Element(String * sDisplayName)
{
	CFolderBase * pRet = 0;
	IEnumerator * pWalker = this->GetEnumerator();
	while(pWalker->MoveNext()){
		CFolderBase * pFolder = __try_cast<CFolderBase*>(pWalker->Current);
		if(0 == String::Compare(pFolder->DisplayName, sDisplayName, true)){
			pRet = pFolder;
			break;
		}
	}
	return pRet;
}


// ####################################################################################
// Methods
// ####################################################################################

void NFolderCollection::Add(CFolderBase * pFolder)
{
	if(pFolder == NULL){
		throw new ArgumentNullException();
	}
	if(pFolder->ParentFolder != m_pParentFolder){
		throw new ArgumentException(S"Wrong parent folder.");
	}
	this->InnerList->Add(pFolder); // ... validate display name uniqueness (no case)
}
