// ####################################################################################
// Includes
// ####################################################################################

#include "stdafx.h"
#include "internal.h"

using namespace GregorView::Internal;
using namespace GregorView::Managed;


// ####################################################################################
// Init/Fin
// ####################################################################################

NGregorViewExtensionPoints::NGregorViewExtensionPoints(void)
{
	memset(m_Array, 0, sizeof(m_Array));
	m_Count = 0;
}

NGregorViewExtensionPoints::~NGregorViewExtensionPoints(void)
{
	for(int i = 0; i < m_Count; i++){
		delete m_Array[i];
	}
}

// ####################################################################################
// Methods
// ####################################################################################

CGregorViewExtensionPoint * NGregorViewExtensionPoints::GetOrCreate(REFCLSID rclsid)
{
	// try to get
	for(int i = 0; i < MAX_EXTENSION_POINTS; i++){
		CGregorViewExtensionPoint * p = m_Array[i];
		if(p != NULL){
			CLSID clsid = p->GetClassId();
			if(clsid == rclsid){
				return p;
			}
		}
	}
	// else create, if limit not reached
	if(m_Count < MAX_EXTENSION_POINTS){		
		// convert class ID to string (registry format)
		LPOLESTR pwsz = NULL;
		if(S_OK != StringFromCLSID(rclsid, &pwsz)){
			return NULL;
		}
		if(pwsz == NULL){
			return NULL;
		}
		// convert to ANSI string
		char szClsId[100];
		if(0 == WideCharToMultiByte(CP_ACP, 0, pwsz, -1, szClsId, sizeof(szClsId), NULL, NULL)){
			return NULL;
		}
		// check registry information for managed implementation
		char szManagedDllPath[MAX_PATH];
		if(false == GetManagedImplementationPath(szClsId, szManagedDllPath, sizeof(szManagedDllPath))){
			return NULL;
		}
		// create
		CGregorViewExtensionPoint * pRet = new CGregorViewExtensionPoint(rclsid, szClsId, szManagedDllPath);
		if(pRet != NULL){
			// insert, increase counter
			m_Array[m_Count] = pRet;
			m_Count++;
		}
		// return
		return pRet;
	}
}
