// ####################################################################################
// Includes
// ####################################################################################

#include "stdafx.h"
#include "internal.h"

#using <mscorlib.dll>

using namespace System;
using namespace System::Runtime::InteropServices;
using namespace GregorView::Internal;


// ####################################################################################
// Functions
// ####################################################################################

System::String * GregorView::Internal::CStringToSysString(const char * psz)
{
	if(psz == NULL){
		return NULL;
	}
	IntPtr ptr = IntPtr((void*)psz);
	String * ps = Marshal::PtrToStringAnsi(ptr);
	return ps;
}

const char * GregorView::Internal::SysStringToCString(System::String * ps)
{
	if(ps == NULL){
		return NULL;
	}
	IntPtr ptr = Marshal::StringToHGlobalAnsi(ps);
	if(ptr == IntPtr::Zero){
		return NULL;
	}
	void * p = ptr.ToPointer();
	return (const char *) p;
}

void GregorView::Internal::FreeHGlobal(System::IntPtr ptr)
{
	if(ptr == IntPtr::Zero){
		return;
	}
	Marshal::FreeHGlobal(ptr);
}

void GregorView::Internal::FreeHGlobal(void * p)
{
	IntPtr ptr = IntPtr(p);
	FreeHGlobal(ptr);
}

void GregorView::Internal::FreeHGlobal(const char * psz)
{
	FreeHGlobal((void*)psz);
}
