// ####################################################################################
// Includes
// ####################################################################################

#include "stdafx.h"
#include "internal.h"

using namespace GregorView::Internal;


// ####################################################################################
// Text Windows
// ####################################################################################

HWND GregorView::Internal::CreateTextWindow(HWND hWndParent, RECT * prcView)
{
	HWND hWnd = CreateWindow("EDIT", "Gregor's World",
					WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE | WS_VSCROLL | WS_BORDER | ES_MULTILINE | ES_WANTRETURN,
					prcView->left, prcView->top, prcView->right - prcView->left, prcView->bottom - prcView->top,
					hWndParent, NULL, (HINSTANCE)::GetLibraryHandle(), NULL);
	if(hWnd == NULL){
		return NULL;
	}
	ShowWindow(hWnd, SW_SHOW);
	SetWindowText(hWnd, "Gregor's World");
	HFONT hFont = ::CreateFont(16, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE, ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_DONTCARE, "Tahoma");
	if(hFont != NULL){
		::SendMessage(hWnd, WM_SETFONT, (WPARAM)hFont, TRUE);
	}
	return hWnd;
}

void GregorView::Internal::DestroyTextWindow(HWND hWnd)
{
	HFONT hFont = (HFONT) ::SendMessage(hWnd, WM_GETFONT, 0, 0);
	if(hFont != NULL){
		::DeleteObject(hFont);
	}
	DestroyWindow(hWnd);
}